#!/bin/bash
SETITER="
%- Set iteration -------------------------------------------------
edge1(X,Y) v edge1(Y,X) :- edge(X,Y), edge(Y,X).
edge1(X,Y) :- edge(X,Y), not edge(Y,X).

all_reached  :- last(X), all_reached_upto(X).
all_reached_upto(X) :- all_reached_upto(Y), succ(Y,X), reached(X).
all_reached_upto(X) :- first(X), reached(X).

reached(X) :- start(X).
reached(X) :- reached(Y), edge1(Y,X).

edge1(X,Y) :- all_reached, edge(X,Y).

node(a). node(b). node(c).
edge(a,b). edge(b,a). edge(b,c).
start(a).

first(a).
succ(b,a).
succ(a,b).
succ(b,c).
last(c).
%-----------------------------------------------------------------
"
echo -e "$SETITER"
echo -e "$SETITER" | dlv --
